/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


module NMM {
interface ICamera {
  void setBrightness(in nmm_int32 value);
  void setAutoExposure(in nmm_int32 value);
  void setSharpness(in nmm_int32 value);
  void setWhiteBalance(in nmm_int32 value);
  void setBlueBalance(in nmm_int32 value);
  void setRedBalance(in nmm_int32 value);

  void setHue(in nmm_int32 value);
  void setSaturation(in nmm_int32 value);
  void setGamma(in nmm_int32 value);
  void setShutter(in nmm_int32 value);
  void setGain(in nmm_int32 value);
  void setIris(in nmm_int32 value);
  void setFocus(in nmm_int32 value);
  void setZoom(in nmm_int32 value);
  void onePush();


  nmm_int32 getBrightness()                       const;
  nmm_int32 getAutoExposure()                     const;
  nmm_int32 getSharpness()                        const;
  nmm_int32 getWhiteBalance()                     const;
  nmm_int32 getBlueBalance()                      const;
  nmm_int32 getRedBalance()                       const;
  nmm_int32 getHue()                              const;
  nmm_int32 getSaturation()                       const;
  nmm_int32 getGamma()                            const;
  nmm_int32 getShutter()                          const;
  nmm_int32 getGain()                             const;
  nmm_int32 getIris()                             const;
  nmm_int32 getFocus()                            const;
  nmm_int32 getZoom()                             const;


  pair<nmm_int32, nmm_int32> getBrightnessRange()       const;
  pair<nmm_int32, nmm_int32> getAutoExposureRange()     const;
  pair<nmm_int32, nmm_int32> getSharpnessRange()        const;
  pair<nmm_int32, nmm_int32> getWhiteBalanceRange()     const;
  pair<nmm_int32, nmm_int32> getHueRange()              const;
  pair<nmm_int32, nmm_int32> getSaturationRange()       const;
  pair<nmm_int32, nmm_int32> getGammaRange()            const;
  pair<nmm_int32, nmm_int32> getShutterRange()          const;
  pair<nmm_int32, nmm_int32> getGainRange()             const;
  pair<nmm_int32, nmm_int32> getIrisRange()             const;
  pair<nmm_int32, nmm_int32> getFocusRange()            const;
  pair<nmm_int32, nmm_int32> getZoomRange()             const;


  nmm_bool hasBrightness()                      const;
  nmm_bool hasAutoExposure()                    const;
  nmm_bool hasSharpness()                       const;
  nmm_bool hasWhiteBalance()                    const;
  nmm_bool hasHue()                             const;
  nmm_bool hasSaturation()                      const;
  nmm_bool hasGamma()                           const;
  nmm_bool hasShutter()                         const;
  nmm_bool hasGain()                            const;
  nmm_bool hasIris()                            const;
  nmm_bool hasFocus()                           const;
  nmm_bool hasZoom()                            const;
};
}

